
import java.lang.reflect.Constructor;

public class DataStoreFactory implements IDataStoreFactory
{
    public IDataStore create() throws Exception
    {
        DataStore1 ds1 = CreateDataStore1();

        return (IDataStore) new DataStore(ds1);
    }

    private DataStore1 CreateDataStore1() throws Exception
    {
        String className = System.getProperty("DataStore1");
        String dbConnectionString = System.getProperty("DataBaseConnectionString");
        Object[] arguments = new Object[1];
        arguments[0] = dbConnectionString;

        Class theClass = Class.forName(className);
        Constructor constructor = theClass.getConstructor(new Class[] {String.class});
        return (DataStore1) constructor.newInstance(arguments);
    }
}
